#ifndef _SUBWINDOWINTERFACE_H_NOU_
#define _SUBWINDOWINTERFACE_H_NOU_

#include <QMdiSubWindow>

/**
Interface ktory budu implementovat okna v MDI.
*/
class SubWindowInterface
{
    public:
    /**
    Tato metoda bude riesit nacitanie definicie modelu z ulozeneho XML
    @param file cesta k suboru z ktoreho sa ma citat
    */
    virtual int load(const QString &file) = 0;
    /**
    Tto metoda
    @param file cesta k suboru do ktoreho sa ma zapisovat
    */
    virtual QString save(const QString &dir) = 0;
    /**
    tato metoda nastavy titulok pre MDI sub okno
    */
    virtual void setSubWindowTitle() = 0;
    /**
    Tato metoda by mala vratit nazov pod ktorym sa ma ulozit dany model/stav
    */
    virtual QString getFileName() = 0;
};

#endif // _SUBWINDOWINTERFACE_H_NOU_
