
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison LALR(1) parsers in C++
   
      Copyright (C) 2002, 2003, 2004, 2005, 2006, 2007, 2008 Free Software
   Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

// Take the name prefix into account.
#define yylex   DEVSlex

/* First part of user declarations.  */

/* Line 311 of lalr1.cc  */
#line 1 "parser.yy"

    #include <string>
    #include <math.h>
    #include <limits>
    #include <map>
    #include "CDparser.h"


/* Line 311 of lalr1.cc  */
#line 52 "parser.tab.cc"


#include "parser.tab.hh"

/* User implementation prologue.  */

/* Line 317 of lalr1.cc  */
#line 66 "parser.yy"

    #undef yylex
    #define yylex driver->scanner->lex
    #define NEWSTR new std::string;


/* Line 317 of lalr1.cc  */
#line 68 "parser.tab.cc"

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* FIXME: INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#define YYUSE(e) ((void) (e))

/* Enable debugging if requested.  */
#if YYDEBUG

/* A pseudo ostream that takes yydebug_ into account.  */
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)	\
do {							\
  if (yydebug_)						\
    {							\
      *yycdebug_ << Title << ' ';			\
      yy_symbol_print_ ((Type), (Value), (Location));	\
      *yycdebug_ << std::endl;				\
    }							\
} while (false)

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug_)				\
    yy_reduce_print_ (Rule);		\
} while (false)

# define YY_STACK_PRINT()		\
do {					\
  if (yydebug_)				\
    yystack_print_ ();			\
} while (false)

#else /* !YYDEBUG */

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_REDUCE_PRINT(Rule)
# define YY_STACK_PRINT()

#endif /* !YYDEBUG */

#define yyerrok		(yyerrstatus_ = 0)
#define yyclearin	(yychar = yyempty_)

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)


/* Line 380 of lalr1.cc  */
#line 1 "[Bison:b4_percent_define_default]"

namespace DEVS {

/* Line 380 of lalr1.cc  */
#line 137 "parser.tab.cc"
#if YYERROR_VERBOSE

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  Parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr = "";
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              /* Fall through.  */
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

#endif

  /// Build a parser object.
  Parser::Parser (class CDparser *driver_yyarg)
    :
#if YYDEBUG
      yydebug_ (false),
      yycdebug_ (&std::cerr),
#endif
      driver (driver_yyarg)
  {
  }

  Parser::~Parser ()
  {
  }

#if YYDEBUG
  /*--------------------------------.
  | Print this symbol on YYOUTPUT.  |
  `--------------------------------*/

  inline void
  Parser::yy_symbol_value_print_ (int yytype,
			   const semantic_type* yyvaluep, const location_type* yylocationp)
  {
    YYUSE (yylocationp);
    YYUSE (yyvaluep);
    switch (yytype)
      {
         default:
	  break;
      }
  }


  void
  Parser::yy_symbol_print_ (int yytype,
			   const semantic_type* yyvaluep, const location_type* yylocationp)
  {
    *yycdebug_ << (yytype < yyntokens_ ? "token" : "nterm")
	       << ' ' << yytname_[yytype] << " ("
	       << *yylocationp << ": ";
    yy_symbol_value_print_ (yytype, yyvaluep, yylocationp);
    *yycdebug_ << ')';
  }
#endif

  void
  Parser::yydestruct_ (const char* yymsg,
			   int yytype, semantic_type* yyvaluep, location_type* yylocationp)
  {
    YYUSE (yylocationp);
    YYUSE (yymsg);
    YYUSE (yyvaluep);

    YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

    switch (yytype)
      {
        case 27: /* "COND_REAL_FUNC" */

/* Line 480 of lalr1.cc  */
#line 63 "parser.yy"
	{ delete (yyvaluep->stringVal); };

/* Line 480 of lalr1.cc  */
#line 244 "parser.tab.cc"
	break;
      case 34: /* "\"const function\"" */

/* Line 480 of lalr1.cc  */
#line 63 "parser.yy"
	{ delete (yyvaluep->stringVal); };

/* Line 480 of lalr1.cc  */
#line 253 "parser.tab.cc"
	break;
      case 35: /* "\"without parameter function\"" */

/* Line 480 of lalr1.cc  */
#line 63 "parser.yy"
	{ delete (yyvaluep->stringVal); };

/* Line 480 of lalr1.cc  */
#line 262 "parser.tab.cc"
	break;
      case 36: /* "\"unary function\"" */

/* Line 480 of lalr1.cc  */
#line 63 "parser.yy"
	{ delete (yyvaluep->stringVal); };

/* Line 480 of lalr1.cc  */
#line 271 "parser.tab.cc"
	break;
      case 37: /* "\"binary function\"" */

/* Line 480 of lalr1.cc  */
#line 63 "parser.yy"
	{ delete (yyvaluep->stringVal); };

/* Line 480 of lalr1.cc  */
#line 280 "parser.tab.cc"
	break;
      case 49: /* "STRING" */

/* Line 480 of lalr1.cc  */
#line 63 "parser.yy"
	{ delete (yyvaluep->stringVal); };

/* Line 480 of lalr1.cc  */
#line 289 "parser.tab.cc"
	break;
      case 55: /* "SECNAME" */

/* Line 480 of lalr1.cc  */
#line 63 "parser.yy"
	{ delete (yyvaluep->stringVal); };

/* Line 480 of lalr1.cc  */
#line 298 "parser.tab.cc"
	break;
      case 58: /* "RULELIST" */

/* Line 480 of lalr1.cc  */
#line 63 "parser.yy"
	{ delete (yyvaluep->stringVal); };

/* Line 480 of lalr1.cc  */
#line 307 "parser.tab.cc"
	break;
      case 59: /* "RULE" */

/* Line 480 of lalr1.cc  */
#line 63 "parser.yy"
	{ delete (yyvaluep->stringVal); };

/* Line 480 of lalr1.cc  */
#line 316 "parser.tab.cc"
	break;
      case 60: /* "ELSERULE" */

/* Line 480 of lalr1.cc  */
#line 63 "parser.yy"
	{ delete (yyvaluep->stringVal); };

/* Line 480 of lalr1.cc  */
#line 325 "parser.tab.cc"
	break;
      case 61: /* "RESULT" */

/* Line 480 of lalr1.cc  */
#line 63 "parser.yy"
	{ delete (yyvaluep->stringVal); };

/* Line 480 of lalr1.cc  */
#line 334 "parser.tab.cc"
	break;
      case 62: /* "BOOLEXP" */

/* Line 480 of lalr1.cc  */
#line 63 "parser.yy"
	{ delete (yyvaluep->stringVal); };

/* Line 480 of lalr1.cc  */
#line 343 "parser.tab.cc"
	break;
      case 63: /* "REALRELEXP" */

/* Line 480 of lalr1.cc  */
#line 63 "parser.yy"
	{ delete (yyvaluep->stringVal); };

/* Line 480 of lalr1.cc  */
#line 352 "parser.tab.cc"
	break;
      case 64: /* "REALEXP" */

/* Line 480 of lalr1.cc  */
#line 63 "parser.yy"
	{ delete (yyvaluep->stringVal); };

/* Line 480 of lalr1.cc  */
#line 361 "parser.tab.cc"
	break;
      case 65: /* "IDREF" */

/* Line 480 of lalr1.cc  */
#line 63 "parser.yy"
	{ delete (yyvaluep->stringVal); };

/* Line 480 of lalr1.cc  */
#line 370 "parser.tab.cc"
	break;
      case 70: /* "FUNCTION" */

/* Line 480 of lalr1.cc  */
#line 63 "parser.yy"
	{ delete (yyvaluep->stringVal); };

/* Line 480 of lalr1.cc  */
#line 379 "parser.tab.cc"
	break;
      case 71: /* "CELLREF" */

/* Line 480 of lalr1.cc  */
#line 63 "parser.yy"
	{ delete (yyvaluep->stringVal); };

/* Line 480 of lalr1.cc  */
#line 388 "parser.tab.cc"
	break;
      case 73: /* "PORTNAME" */

/* Line 480 of lalr1.cc  */
#line 63 "parser.yy"
	{ delete (yyvaluep->stringVal); };

/* Line 480 of lalr1.cc  */
#line 397 "parser.tab.cc"
	break;

	default:
	  break;
      }
  }

  void
  Parser::yypop_ (unsigned int n)
  {
    yystate_stack_.pop (n);
    yysemantic_stack_.pop (n);
    yylocation_stack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  Parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  Parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  Parser::debug_level_type
  Parser::debug_level () const
  {
    return yydebug_;
  }

  void
  Parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif

  int
  Parser::parse ()
  {
    /// Lookahead and lookahead in internal form.
    int yychar = yyempty_;
    int yytoken = 0;

    /* State.  */
    int yyn;
    int yylen = 0;
    int yystate = 0;

    /* Error handling.  */
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// Semantic value of the lookahead.
    semantic_type yylval;
    /// Location of the lookahead.
    location_type yylloc;
    /// The locations where the error started and ended.
    location_type yyerror_range[2];

    /// $$.
    semantic_type yyval;
    /// @$.
    location_type yyloc;

    int yyresult;

    YYCDEBUG << "Starting parse" << std::endl;


    /* Initialize the stacks.  The initial state will be pushed in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystate_stack_ = state_stack_type (0);
    yysemantic_stack_ = semantic_stack_type (0);
    yylocation_stack_ = location_stack_type (0);
    yysemantic_stack_.push (yylval);
    yylocation_stack_.push (yylloc);

    /* New state.  */
  yynewstate:
    yystate_stack_.push (yystate);
    YYCDEBUG << "Entering state " << yystate << std::endl;

    /* Accept?  */
    if (yystate == yyfinal_)
      goto yyacceptlab;

    goto yybackup;

    /* Backup.  */
  yybackup:

    /* Try to take a decision without lookahead.  */
    yyn = yypact_[yystate];
    if (yyn == yypact_ninf_)
      goto yydefault;

    /* Read a lookahead token.  */
    if (yychar == yyempty_)
      {
	YYCDEBUG << "Reading a token: ";
	yychar = yylex (&yylval, &yylloc);
      }


    /* Convert token to internal form.  */
    if (yychar <= yyeof_)
      {
	yychar = yytoken = yyeof_;
	YYCDEBUG << "Now at end of input." << std::endl;
      }
    else
      {
	yytoken = yytranslate_ (yychar);
	YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
      }

    /* If the proper action on seeing token YYTOKEN is to reduce or to
       detect an error, take that action.  */
    yyn += yytoken;
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yytoken)
      goto yydefault;

    /* Reduce or error.  */
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
	if (yyn == 0 || yyn == yytable_ninf_)
	goto yyerrlab;
	yyn = -yyn;
	goto yyreduce;
      }

    /* Shift the lookahead token.  */
    YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

    /* Discard the token being shifted.  */
    yychar = yyempty_;

    yysemantic_stack_.push (yylval);
    yylocation_stack_.push (yylloc);

    /* Count tokens shifted since error; after three, turn off error
       status.  */
    if (yyerrstatus_)
      --yyerrstatus_;

    yystate = yyn;
    goto yynewstate;

  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[yystate];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;

  /*-----------------------------.
  | yyreduce -- Do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    /* If YYLEN is nonzero, implement the default value of the action:
       `$$ = $1'.  Otherwise, use the top of the stack.

       Otherwise, the following line sets YYVAL to garbage.
       This behavior is undocumented and Bison
       users should not rely upon it.  */
    if (yylen)
      yyval = yysemantic_stack_[yylen - 1];
    else
      yyval = yysemantic_stack_[0];

    {
      slice<location_type, location_stack_type> slice (yylocation_stack_, yylen);
      YYLLOC_DEFAULT (yyloc, slice, yylen);
    }
    YY_REDUCE_PRINT (yyn);
    switch (yyn)
      {
	  case 6:

/* Line 678 of lalr1.cc  */
#line 81 "parser.yy"
    { if(driver->model.setSection(driver->params))driver->error << "Duplicated model definition section or wrong parameter.\n"; driver->params.clear(); delete (yysemantic_stack_[(2) - (1)].stringVal); }
    break;

  case 7:

/* Line 678 of lalr1.cc  */
#line 82 "parser.yy"
    { if(driver->model.addRule(*(yysemantic_stack_[(2) - (1)].stringVal), *(yysemantic_stack_[(2) - (2)].stringVal)))driver->error << "Duplicated rule section." << *(yysemantic_stack_[(2) - (1)].stringVal) << endl; delete (yysemantic_stack_[(2) - (1)].stringVal); delete (yysemantic_stack_[(2) - (2)].stringVal); }
    break;

  case 8:

/* Line 678 of lalr1.cc  */
#line 84 "parser.yy"
    { (yyval.stringVal) = (yysemantic_stack_[(3) - (2)].stringVal); }
    break;

  case 11:

/* Line 678 of lalr1.cc  */
#line 89 "parser.yy"
    { driver->params.push_back(Param("zone", *(yysemantic_stack_[(10) - (3)].stringVal), (yysemantic_stack_[(10) - (6)].intVal), (yysemantic_stack_[(10) - (8)].intVal), (yysemantic_stack_[(10) - (6)].intVal), (yysemantic_stack_[(10) - (8)].intVal))); delete (yysemantic_stack_[(10) - (3)].stringVal); }
    break;

  case 12:

/* Line 678 of lalr1.cc  */
#line 90 "parser.yy"
    { driver->params.push_back(Param("zone", *(yysemantic_stack_[(16) - (3)].stringVal), (yysemantic_stack_[(16) - (6)].intVal), (yysemantic_stack_[(16) - (8)].intVal), (yysemantic_stack_[(16) - (12)].intVal), (yysemantic_stack_[(16) - (14)].intVal))); delete (yysemantic_stack_[(16) - (3)].stringVal); }
    break;

  case 13:

/* Line 678 of lalr1.cc  */
#line 91 "parser.yy"
    { driver->params.push_back(Param(*(yysemantic_stack_[(3) - (1)].stringVal), *(yysemantic_stack_[(3) - (3)].stringVal))); delete (yysemantic_stack_[(3) - (1)].stringVal); delete (yysemantic_stack_[(3) - (3)].stringVal); }
    break;

  case 14:

/* Line 678 of lalr1.cc  */
#line 92 "parser.yy"
    { driver->params.push_back(Param(*(yysemantic_stack_[(3) - (1)].stringVal), driver->toString((yysemantic_stack_[(3) - (3)].doubleVal)))); delete (yysemantic_stack_[(3) - (1)].stringVal); }
    break;

  case 15:

/* Line 678 of lalr1.cc  */
#line 93 "parser.yy"
    { driver->params.push_back(Param(*(yysemantic_stack_[(4) - (1)].stringVal), *(yysemantic_stack_[(4) - (4)].stringVal))); delete (yysemantic_stack_[(4) - (1)].stringVal); delete (yysemantic_stack_[(4) - (3)].stringVal); delete (yysemantic_stack_[(4) - (4)].stringVal); }
    break;

  case 16:

/* Line 678 of lalr1.cc  */
#line 95 "parser.yy"
    { (yyval.stringVal) = (yysemantic_stack_[(1) - (1)].stringVal); }
    break;

  case 17:

/* Line 678 of lalr1.cc  */
#line 96 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = *(yysemantic_stack_[(2) - (1)].stringVal) + "\n" + *(yysemantic_stack_[(2) - (2)].stringVal); delete (yysemantic_stack_[(2) - (1)].stringVal); delete (yysemantic_stack_[(2) - (2)].stringVal); }
    break;

  case 18:

/* Line 678 of lalr1.cc  */
#line 97 "parser.yy"
    { (yyval.stringVal)=(yysemantic_stack_[(1) - (1)].stringVal); }
    break;

  case 19:

/* Line 678 of lalr1.cc  */
#line 98 "parser.yy"
    { (yyval.stringVal) = (yysemantic_stack_[(2) - (2)].stringVal); }
    break;

  case 20:

/* Line 678 of lalr1.cc  */
#line 100 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = "if("+*(yysemantic_stack_[(7) - (6)].stringVal)+"){ new_event.state="+*(yysemantic_stack_[(7) - (3)].stringVal)+"; new_event.time="+*(yysemantic_stack_[(7) - (4)].stringVal)+"; return new_event; }"; delete (yysemantic_stack_[(7) - (6)].stringVal); delete (yysemantic_stack_[(7) - (3)].stringVal); delete (yysemantic_stack_[(7) - (4)].stringVal); }
    break;

  case 21:

/* Line 678 of lalr1.cc  */
#line 101 "parser.yy"
    { (yyval.stringVal) = NEWSTR; delete (yysemantic_stack_[(7) - (3)].stringVal); delete (yysemantic_stack_[(7) - (4)].stringVal); }
    break;

  case 22:

/* Line 678 of lalr1.cc  */
#line 103 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal)="return "+*(yysemantic_stack_[(1) - (1)].stringVal)+"(current_state, current_time, event_vector, seed);\n"; delete (yysemantic_stack_[(1) - (1)].stringVal); }
    break;

  case 23:

/* Line 678 of lalr1.cc  */
#line 105 "parser.yy"
    { (yyval.stringVal)=NEWSTR; if(isnan((yysemantic_stack_[(1) - (1)].doubleVal)))*(yyval.stringVal) = " NAN "; else *(yyval.stringVal) = driver->toString((yysemantic_stack_[(1) - (1)].doubleVal)); }
    break;

  case 24:

/* Line 678 of lalr1.cc  */
#line 106 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = "("+*(yysemantic_stack_[(3) - (2)].stringVal)+")"; delete (yysemantic_stack_[(3) - (2)].stringVal); }
    break;

  case 25:

/* Line 678 of lalr1.cc  */
#line 108 "parser.yy"
    { (yyval.stringVal)=NEWSTR; if(isnan((yysemantic_stack_[(1) - (1)].doubleVal)))*(yyval.stringVal) = " NAN "; else *(yyval.stringVal) = driver->toString((yysemantic_stack_[(1) - (1)].doubleVal)); }
    break;

  case 26:

/* Line 678 of lalr1.cc  */
#line 109 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = "("+*(yysemantic_stack_[(3) - (2)].stringVal)+")"; delete (yysemantic_stack_[(3) - (2)].stringVal); }
    break;

  case 27:

/* Line 678 of lalr1.cc  */
#line 110 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = *(yysemantic_stack_[(1) - (1)].stringVal); delete (yysemantic_stack_[(1) - (1)].stringVal); }
    break;

  case 28:

/* Line 678 of lalr1.cc  */
#line 111 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = "!("+*(yysemantic_stack_[(2) - (2)].stringVal)+")"; delete (yysemantic_stack_[(2) - (2)].stringVal); }
    break;

  case 29:

/* Line 678 of lalr1.cc  */
#line 112 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = "DEVS_and("+*(yysemantic_stack_[(3) - (1)].stringVal)+","+*(yysemantic_stack_[(3) - (3)].stringVal)+") "; delete (yysemantic_stack_[(3) - (1)].stringVal); delete (yysemantic_stack_[(3) - (3)].stringVal); }
    break;

  case 30:

/* Line 678 of lalr1.cc  */
#line 113 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = "DEVS_or("+*(yysemantic_stack_[(3) - (1)].stringVal)+","+*(yysemantic_stack_[(3) - (3)].stringVal)+") "; delete (yysemantic_stack_[(3) - (1)].stringVal); delete (yysemantic_stack_[(3) - (3)].stringVal); }
    break;

  case 31:

/* Line 678 of lalr1.cc  */
#line 114 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = "DEVS_xor("+*(yysemantic_stack_[(3) - (1)].stringVal)+", "+*(yysemantic_stack_[(3) - (3)].stringVal)+") "; delete (yysemantic_stack_[(3) - (1)].stringVal); delete (yysemantic_stack_[(3) - (3)].stringVal); }
    break;

  case 32:

/* Line 678 of lalr1.cc  */
#line 115 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = "DEVS_imp("+*(yysemantic_stack_[(3) - (1)].stringVal)+", "+*(yysemantic_stack_[(3) - (3)].stringVal)+") "; delete (yysemantic_stack_[(3) - (1)].stringVal); delete (yysemantic_stack_[(3) - (3)].stringVal); }
    break;

  case 33:

/* Line 678 of lalr1.cc  */
#line 116 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = "DEVS_eqv("+*(yysemantic_stack_[(3) - (1)].stringVal)+", "+*(yysemantic_stack_[(3) - (3)].stringVal)+") "; delete (yysemantic_stack_[(3) - (1)].stringVal); delete (yysemantic_stack_[(3) - (3)].stringVal); }
    break;

  case 34:

/* Line 678 of lalr1.cc  */
#line 118 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = *(yysemantic_stack_[(3) - (1)].stringVal)+"!="+*(yysemantic_stack_[(3) - (3)].stringVal); delete (yysemantic_stack_[(3) - (1)].stringVal); delete (yysemantic_stack_[(3) - (3)].stringVal); }
    break;

  case 35:

/* Line 678 of lalr1.cc  */
#line 119 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = *(yysemantic_stack_[(3) - (1)].stringVal)+"=="+*(yysemantic_stack_[(3) - (3)].stringVal); delete (yysemantic_stack_[(3) - (1)].stringVal); delete (yysemantic_stack_[(3) - (3)].stringVal); }
    break;

  case 36:

/* Line 678 of lalr1.cc  */
#line 120 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = *(yysemantic_stack_[(3) - (1)].stringVal)+">"+*(yysemantic_stack_[(3) - (3)].stringVal); delete (yysemantic_stack_[(3) - (1)].stringVal); delete (yysemantic_stack_[(3) - (3)].stringVal); }
    break;

  case 37:

/* Line 678 of lalr1.cc  */
#line 121 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = *(yysemantic_stack_[(3) - (1)].stringVal)+"<"+*(yysemantic_stack_[(3) - (3)].stringVal); delete (yysemantic_stack_[(3) - (1)].stringVal); delete (yysemantic_stack_[(3) - (3)].stringVal); }
    break;

  case 38:

/* Line 678 of lalr1.cc  */
#line 122 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = *(yysemantic_stack_[(3) - (1)].stringVal)+">="+*(yysemantic_stack_[(3) - (3)].stringVal); delete (yysemantic_stack_[(3) - (1)].stringVal); delete (yysemantic_stack_[(3) - (3)].stringVal); }
    break;

  case 39:

/* Line 678 of lalr1.cc  */
#line 123 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = *(yysemantic_stack_[(3) - (1)].stringVal)+"<="+*(yysemantic_stack_[(3) - (3)].stringVal); delete (yysemantic_stack_[(3) - (1)].stringVal); delete (yysemantic_stack_[(3) - (3)].stringVal); }
    break;

  case 40:

/* Line 678 of lalr1.cc  */
#line 124 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = *(yysemantic_stack_[(4) - (1)].stringVal)+"("+*(yysemantic_stack_[(4) - (3)].stringVal)+")"; delete (yysemantic_stack_[(4) - (1)].stringVal); delete (yysemantic_stack_[(4) - (3)].stringVal); }
    break;

  case 41:

/* Line 678 of lalr1.cc  */
#line 126 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = *(yysemantic_stack_[(1) - (1)].stringVal); delete (yysemantic_stack_[(1) - (1)].stringVal); }
    break;

  case 42:

/* Line 678 of lalr1.cc  */
#line 127 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = "("+*(yysemantic_stack_[(3) - (2)].stringVal)+")"; delete (yysemantic_stack_[(3) - (2)].stringVal); }
    break;

  case 43:

/* Line 678 of lalr1.cc  */
#line 128 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = *(yysemantic_stack_[(3) - (1)].stringVal)+"+"+*(yysemantic_stack_[(3) - (3)].stringVal); delete (yysemantic_stack_[(3) - (1)].stringVal); delete (yysemantic_stack_[(3) - (3)].stringVal); }
    break;

  case 44:

/* Line 678 of lalr1.cc  */
#line 129 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = *(yysemantic_stack_[(3) - (1)].stringVal)+"-"+*(yysemantic_stack_[(3) - (3)].stringVal); delete (yysemantic_stack_[(3) - (1)].stringVal); delete (yysemantic_stack_[(3) - (3)].stringVal); }
    break;

  case 45:

/* Line 678 of lalr1.cc  */
#line 130 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = *(yysemantic_stack_[(3) - (1)].stringVal)+"*"+*(yysemantic_stack_[(3) - (3)].stringVal); delete (yysemantic_stack_[(3) - (1)].stringVal); delete (yysemantic_stack_[(3) - (3)].stringVal); }
    break;

  case 46:

/* Line 678 of lalr1.cc  */
#line 131 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = *(yysemantic_stack_[(3) - (1)].stringVal)+"/"+*(yysemantic_stack_[(3) - (3)].stringVal); delete (yysemantic_stack_[(3) - (1)].stringVal); delete (yysemantic_stack_[(3) - (3)].stringVal); }
    break;

  case 47:

/* Line 678 of lalr1.cc  */
#line 133 "parser.yy"
    { (yyval.stringVal) = NEWSTR; if(*(yysemantic_stack_[(1) - (1)].stringVal)=="(0,0)")*(yyval.stringVal) = "current_state"; else *(yyval.stringVal) = "event_vector["+driver->toString(driver->model.section.neighbors_index[*(yysemantic_stack_[(1) - (1)].stringVal)])+"].y"; delete (yysemantic_stack_[(1) - (1)].stringVal); }
    break;

  case 48:

/* Line 678 of lalr1.cc  */
#line 134 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = driver->toString((yysemantic_stack_[(1) - (1)].doubleVal)); }
    break;

  case 49:

/* Line 678 of lalr1.cc  */
#line 135 "parser.yy"
    { (yyval.stringVal) = (yysemantic_stack_[(1) - (1)].stringVal); }
    break;

  case 50:

/* Line 678 of lalr1.cc  */
#line 136 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = "portValue("+*(yysemantic_stack_[(4) - (3)].stringVal)+")"; delete (yysemantic_stack_[(4) - (3)].stringVal); }
    break;

  case 51:

/* Line 678 of lalr1.cc  */
#line 137 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = "send("+*(yysemantic_stack_[(6) - (3)].stringVal)+","+*(yysemantic_stack_[(6) - (5)].stringVal)+")"; delete (yysemantic_stack_[(6) - (3)].stringVal); delete (yysemantic_stack_[(6) - (5)].stringVal); }
    break;

  case 52:

/* Line 678 of lalr1.cc  */
#line 138 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = "DEVS_cellPos("+*(yysemantic_stack_[(4) - (3)].stringVal)+")"; delete (yysemantic_stack_[(4) - (3)].stringVal); }
    break;

  case 53:

/* Line 678 of lalr1.cc  */
#line 140 "parser.yy"
    { (yyval.doubleVal) = (yysemantic_stack_[(1) - (1)].intVal); }
    break;

  case 54:

/* Line 678 of lalr1.cc  */
#line 141 "parser.yy"
    { (yyval.doubleVal) = (yysemantic_stack_[(1) - (1)].doubleVal); }
    break;

  case 55:

/* Line 678 of lalr1.cc  */
#line 142 "parser.yy"
    { (yyval.doubleVal) = driver->constFunc((yysemantic_stack_[(1) - (1)].stringVal)); delete (yysemantic_stack_[(1) - (1)].stringVal); }
    break;

  case 56:

/* Line 678 of lalr1.cc  */
#line 143 "parser.yy"
    { (yyval.doubleVal) = NAN; }
    break;

  case 57:

/* Line 678 of lalr1.cc  */
#line 145 "parser.yy"
    { (yyval.intVal) = (yysemantic_stack_[(1) - (1)].intVal); }
    break;

  case 58:

/* Line 678 of lalr1.cc  */
#line 146 "parser.yy"
    { (yyval.intVal) = (yysemantic_stack_[(2) - (1)].intVal)*(yysemantic_stack_[(2) - (2)].intVal); }
    break;

  case 59:

/* Line 678 of lalr1.cc  */
#line 148 "parser.yy"
    { (yyval.doubleVal) = (yysemantic_stack_[(1) - (1)].doubleVal); }
    break;

  case 60:

/* Line 678 of lalr1.cc  */
#line 149 "parser.yy"
    { (yyval.doubleVal) = (yysemantic_stack_[(2) - (1)].intVal)*(yysemantic_stack_[(2) - (2)].doubleVal); }
    break;

  case 61:

/* Line 678 of lalr1.cc  */
#line 151 "parser.yy"
    { (yyval.intVal) = (yysemantic_stack_[(1) - (1)].intVal); }
    break;

  case 62:

/* Line 678 of lalr1.cc  */
#line 152 "parser.yy"
    { (yyval.intVal) = (yysemantic_stack_[(1) - (1)].intVal); }
    break;

  case 63:

/* Line 678 of lalr1.cc  */
#line 154 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = *(yysemantic_stack_[(4) - (1)].stringVal)+"("+*(yysemantic_stack_[(4) - (3)].stringVal)+")"; delete (yysemantic_stack_[(4) - (1)].stringVal); delete (yysemantic_stack_[(4) - (3)].stringVal); }
    break;

  case 64:

/* Line 678 of lalr1.cc  */
#line 155 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = *(yysemantic_stack_[(1) - (1)].stringVal)+"()"; delete (yysemantic_stack_[(1) - (1)].stringVal); }
    break;

  case 65:

/* Line 678 of lalr1.cc  */
#line 156 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = *(yysemantic_stack_[(6) - (1)].stringVal)+"("+*(yysemantic_stack_[(6) - (3)].stringVal)+","+*(yysemantic_stack_[(6) - (5)].stringVal)+")"; delete (yysemantic_stack_[(6) - (1)].stringVal); delete (yysemantic_stack_[(6) - (3)].stringVal); delete (yysemantic_stack_[(6) - (5)].stringVal); }
    break;

  case 66:

/* Line 678 of lalr1.cc  */
#line 157 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = "DEVS_if("+*(yysemantic_stack_[(8) - (3)].stringVal)+","+*(yysemantic_stack_[(8) - (5)].stringVal)+")"; delete (yysemantic_stack_[(8) - (3)].stringVal); delete (yysemantic_stack_[(8) - (5)].stringVal); delete (yysemantic_stack_[(8) - (7)].stringVal); }
    break;

  case 67:

/* Line 678 of lalr1.cc  */
#line 158 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = "DEVS_ifu("+*(yysemantic_stack_[(10) - (3)].stringVal)+","+*(yysemantic_stack_[(10) - (5)].stringVal)+","+*(yysemantic_stack_[(10) - (7)].stringVal)+","+*(yysemantic_stack_[(10) - (9)].stringVal)+")"; delete (yysemantic_stack_[(10) - (3)].stringVal); delete (yysemantic_stack_[(10) - (5)].stringVal); delete (yysemantic_stack_[(10) - (7)].stringVal); delete (yysemantic_stack_[(10) - (9)].stringVal); }
    break;

  case 68:

/* Line 678 of lalr1.cc  */
#line 160 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = "("+driver->toString((yysemantic_stack_[(5) - (2)].intVal))+","+driver->toString((yysemantic_stack_[(5) - (4)].intVal))+")"; }
    break;

  case 69:

/* Line 678 of lalr1.cc  */
#line 165 "parser.yy"
    { (yyval.doubleVal) = 1.0; }
    break;

  case 70:

/* Line 678 of lalr1.cc  */
#line 166 "parser.yy"
    { (yyval.doubleVal) = 0.0; }
    break;

  case 71:

/* Line 678 of lalr1.cc  */
#line 167 "parser.yy"
    { (yyval.doubleVal) = NAN; }
    break;

  case 72:

/* Line 678 of lalr1.cc  */
#line 169 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = "thisPort"; }
    break;

  case 73:

/* Line 678 of lalr1.cc  */
#line 170 "parser.yy"
    { (yyval.stringVal)=NEWSTR; *(yyval.stringVal) = *(yysemantic_stack_[(1) - (1)].stringVal); delete (yysemantic_stack_[(1) - (1)].stringVal); }
    break;



/* Line 678 of lalr1.cc  */
#line 1052 "parser.tab.cc"
	default:
          break;
      }
    YY_SYMBOL_PRINT ("-> $$ =", yyr1_[yyn], &yyval, &yyloc);

    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();

    yysemantic_stack_.push (yyval);
    yylocation_stack_.push (yyloc);

    /* Shift the result of the reduction.  */
    yyn = yyr1_[yyn];
    yystate = yypgoto_[yyn - yyntokens_] + yystate_stack_[0];
    if (0 <= yystate && yystate <= yylast_
	&& yycheck_[yystate] == yystate_stack_[0])
      yystate = yytable_[yystate];
    else
      yystate = yydefgoto_[yyn - yyntokens_];
    goto yynewstate;

  /*------------------------------------.
  | yyerrlab -- here on detecting error |
  `------------------------------------*/
  yyerrlab:
    /* If not already recovering from an error, report this error.  */
    if (!yyerrstatus_)
      {
	++yynerrs_;
	error (yylloc, yysyntax_error_ (yystate, yytoken));
      }

    yyerror_range[0] = yylloc;
    if (yyerrstatus_ == 3)
      {
	/* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

	if (yychar <= yyeof_)
	  {
	  /* Return failure if at end of input.  */
	  if (yychar == yyeof_)
	    YYABORT;
	  }
	else
	  {
	    yydestruct_ ("Error: discarding", yytoken, &yylval, &yylloc);
	    yychar = yyempty_;
	  }
      }

    /* Else will try to reuse lookahead token after shifting the error
       token.  */
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:

    /* Pacify compilers like GCC when the user code never invokes
       YYERROR and the label yyerrorlab therefore never appears in user
       code.  */
    if (false)
      goto yyerrorlab;

    yyerror_range[0] = yylocation_stack_[yylen - 1];
    /* Do not reclaim the symbols of the rule which action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    yystate = yystate_stack_[0];
    goto yyerrlab1;

  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;	/* Each real token shifted decrements this.  */

    for (;;)
      {
	yyn = yypact_[yystate];
	if (yyn != yypact_ninf_)
	{
	  yyn += yyterror_;
	  if (0 <= yyn && yyn <= yylast_ && yycheck_[yyn] == yyterror_)
	    {
	      yyn = yytable_[yyn];
	      if (0 < yyn)
		break;
	    }
	}

	/* Pop the current state because it cannot handle the error token.  */
	if (yystate_stack_.height () == 1)
	YYABORT;

	yyerror_range[0] = yylocation_stack_[0];
	yydestruct_ ("Error: popping",
		     yystos_[yystate],
		     &yysemantic_stack_[0], &yylocation_stack_[0]);
	yypop_ ();
	yystate = yystate_stack_[0];
	YY_STACK_PRINT ();
      }

    yyerror_range[1] = yylloc;
    // Using YYLLOC is tempting, but would change the location of
    // the lookahead.  YYLOC is available though.
    YYLLOC_DEFAULT (yyloc, (yyerror_range - 1), 2);
    yysemantic_stack_.push (yylval);
    yylocation_stack_.push (yyloc);

    /* Shift the error token.  */
    YY_SYMBOL_PRINT ("Shifting", yystos_[yyn],
		     &yysemantic_stack_[0], &yylocation_stack_[0]);

    yystate = yyn;
    goto yynewstate;

    /* Accept.  */
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;

    /* Abort.  */
  yyabortlab:
    yyresult = 1;
    goto yyreturn;

  yyreturn:
    if (yychar != yyempty_)
      yydestruct_ ("Cleanup: discarding lookahead", yytoken, &yylval, &yylloc);

    /* Do not reclaim the symbols of the rule which action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    while (yystate_stack_.height () != 1)
      {
	yydestruct_ ("Cleanup: popping",
		   yystos_[yystate_stack_[0]],
		   &yysemantic_stack_[0],
		   &yylocation_stack_[0]);
	yypop_ ();
      }

    return yyresult;
  }

  // Generate an error message.
  std::string
  Parser::yysyntax_error_ (int yystate, int tok)
  {
    std::string res;
    YYUSE (yystate);
#if YYERROR_VERBOSE
    int yyn = yypact_[yystate];
    if (yypact_ninf_ < yyn && yyn <= yylast_)
      {
	/* Start YYX at -YYN if negative to avoid negative indexes in
	   YYCHECK.  */
	int yyxbegin = yyn < 0 ? -yyn : 0;

	/* Stay within bounds of both yycheck and yytname.  */
	int yychecklim = yylast_ - yyn + 1;
	int yyxend = yychecklim < yyntokens_ ? yychecklim : yyntokens_;
	int count = 0;
	for (int x = yyxbegin; x < yyxend; ++x)
	  if (yycheck_[x + yyn] == x && x != yyterror_)
	    ++count;

	// FIXME: This method of building the message is not compatible
	// with internationalization.  It should work like yacc.c does it.
	// That is, first build a string that looks like this:
	// "syntax error, unexpected %s or %s or %s"
	// Then, invoke YY_ on this string.
	// Finally, use the string as a format to output
	// yytname_[tok], etc.
	// Until this gets fixed, this message appears in English only.
	res = "syntax error, unexpected ";
	res += yytnamerr_ (yytname_[tok]);
	if (count < 5)
	  {
	    count = 0;
	    for (int x = yyxbegin; x < yyxend; ++x)
	      if (yycheck_[x + yyn] == x && x != yyterror_)
		{
		  res += (!count++) ? ", expecting " : " or ";
		  res += yytnamerr_ (yytname_[x]);
		}
	  }
      }
    else
#endif
      res = YY_("syntax error");
    return res;
  }


  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
  const signed char Parser::yypact_ninf_ = -65;
  const short int
  Parser::yypact_[] =
  {
        20,   -13,    11,    33,    36,   -65,     5,   -65,    33,    13,
     -16,    48,   -65,     1,    39,    40,    42,   -65,   -16,   -65,
      23,   -65,    42,   -65,   -65,   -65,   -65,   216,    41,   256,
     -65,   -65,   172,   -65,   -65,   -65,   -65,   -65,   -65,   216,
     -65,   -65,   -65,     4,    86,    89,   -65,   172,    98,   100,
     101,   104,   105,   -65,   107,   110,    69,   -65,   -65,   -65,
     -65,   109,   -65,   -65,   117,    32,   -65,    65,    88,   -28,
     -28,   172,   151,   151,   172,   172,   -65,   172,   172,   172,
     172,   116,    32,    88,    84,   -65,    32,   -65,   -65,   131,
      99,   219,   151,   151,   -65,   -65,   -65,   136,    -3,   -65,
     287,   -65,   203,   229,   279,   -65,   -65,    51,    51,   134,
     112,   103,   143,   -65,   172,   -65,   268,   206,   -65,   172,
     151,   151,   151,   151,   151,   172,   172,   172,   172,   172,
     172,   172,   172,   -65,   172,   -65,   -65,    32,   -65,   236,
     -65,   238,   -65,   -65,   -65,   -65,   -65,   299,    12,    12,
      12,    12,    12,    12,   301,   240,   152,   -65,   -65,   172,
     172,   -65,    -1,   250,   303,   -65,   154,   -65,   172,    32,
     269,   120,   -65,    32,   155,   149,   -65
  };

  /* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
     doesn't specify something else to do.  Zero means the default is an
     error.  */
  const unsigned char
  Parser::yydefact_[] =
  {
         0,     0,     0,     4,     0,     1,     0,     2,     4,     0,
       9,     0,     5,     0,     0,     0,    22,     6,     9,     7,
       0,    18,     0,     3,     8,    22,    19,     0,     0,     0,
      10,    17,     0,    56,    55,    57,    61,    62,    59,     0,
      23,    53,    54,     0,     0,    13,    14,     0,     0,     0,
       0,     0,     0,    64,     0,     0,     0,    41,    48,    49,
      47,     0,    58,    60,     0,     0,    15,     0,    53,     0,
       0,     0,     0,     0,     0,     0,    24,     0,     0,     0,
       0,     0,     0,     0,     0,    42,     0,    72,    73,     0,
       0,     0,     0,     0,    69,    70,    71,     0,     0,    27,
       0,    25,     0,     0,     0,    45,    46,    43,    44,     0,
       0,     0,     0,    50,     0,    52,     0,     0,    28,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    63,     0,    21,    20,     0,    68,     0,
      26,     0,    29,    30,    31,    32,    33,     0,    34,    35,
      36,    37,    38,    39,     0,     0,     0,    51,    40,     0,
       0,    65,     0,     0,     0,    11,     0,    66,     0,     0,
       0,     0,    67,     0,     0,     0,    12
  };

  /* YYPGOTO[NTERM-NUM].  */
  const short int
  Parser::yypgoto_[] =
  {
       -65,   -65,   -65,   162,   -65,   -65,    -6,   -65,     6,   -65,
     -65,   121,   -56,   -65,   -32,   -65,    47,   -31,   -65,   -64,
     -65,   126,   -65,   102
  };

  /* YYDEFGOTO[NTERM-NUM].  */
  const signed char
  Parser::yydefgoto_[] =
  {
        -1,     2,     3,     7,     8,     9,    17,    18,    19,    20,
      21,    39,    98,    99,   100,    57,    58,    41,    42,    43,
      59,    60,   101,    89
  };

  /* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule which
     number is the opposite.  If zero, do what YYDEFACT says.  */
  const signed char Parser::yytable_ninf_ = -17;
  const short int
  Parser::yytable_[] =
  {
        56,    84,    13,    87,    23,   165,   120,   121,   122,   123,
     124,     5,    30,    -9,    13,    67,    68,   102,    84,    26,
      -9,    88,    84,   -16,    13,   110,    31,     1,    15,     4,
     -16,    77,    78,    22,    83,   125,   116,   118,   166,    91,
       6,    14,   103,   104,    10,   105,   106,   107,   108,    62,
      25,   111,    63,    14,    11,   112,    24,    15,    79,    80,
     117,    68,    16,    14,   142,   143,   144,   145,   146,    85,
      77,    78,    25,    84,    40,    76,    46,    35,    36,    37,
      27,    28,   139,    29,    77,    78,    40,   141,    77,    78,
      44,    64,    65,   147,   148,   149,   150,   151,   152,   153,
     154,    69,   155,    70,    71,    84,   156,    72,    73,    84,
      74,    79,    80,    75,    81,    79,    80,   109,   136,    92,
      82,   120,   121,   122,   123,   124,    86,   163,   164,    62,
      93,    94,    95,    96,    33,   113,   170,   114,   171,   119,
     135,   137,   174,    97,    48,    49,    50,   138,    51,    52,
      34,    53,    54,    55,    92,   176,   162,   169,   173,   175,
      61,    35,    36,    37,    38,    93,    94,    95,    96,    33,
      12,    66,    90,     0,     0,    47,     0,     0,    97,    48,
      49,    50,     0,    51,    52,    34,    53,    54,    55,     0,
      33,     0,     0,     0,     0,     0,    35,    36,    37,    38,
      48,    49,    50,     0,    51,    52,    34,    53,    54,    55,
      85,     0,   120,   121,   122,   123,   124,    35,    36,    37,
      38,    32,     0,   115,     0,    77,    78,   126,   127,   128,
     129,   130,   131,   133,    33,     0,     0,     0,    77,    78,
     157,   132,   158,     0,   161,     0,     0,     0,    77,    78,
      34,     0,    79,    80,   167,    77,    78,    77,    78,    77,
      78,    35,    36,    37,    38,    79,    80,     0,     0,    77,
      78,     0,   140,   172,    33,    79,    80,   120,   121,   122,
     123,   124,    79,    80,    79,    80,    79,    80,    77,    78,
      34,     0,     0,     0,     0,     0,    79,    80,    77,    78,
       0,    35,    36,    37,    38,    45,    77,    78,   126,   127,
     128,   129,   130,   131,     0,    79,    80,   134,    77,    78,
      77,    78,    77,    78,     0,    79,    80,     0,     0,     0,
       0,     0,     0,    79,    80,     0,     0,   159,     0,   160,
       0,   168,     0,     0,     0,    79,    80,    79,    80,    79,
      80
  };

  /* YYCHECK.  */
  const short int
  Parser::yycheck_[] =
  {
        32,    65,     1,    31,    10,     6,     9,    10,    11,    12,
      13,     0,    18,     0,     1,    47,    47,    73,    82,    13,
       7,    49,    86,     0,     1,    81,    20,     7,    44,    42,
       7,    19,    20,    49,    65,    38,    92,    93,    39,    71,
       7,    40,    74,    75,     8,    77,    78,    79,    80,    45,
      49,    82,    48,    40,    49,    86,     8,    44,    46,    47,
      92,    92,    49,    40,   120,   121,   122,   123,   124,     4,
      19,    20,    49,   137,    27,     6,    29,    45,    46,    47,
      41,    41,   114,    41,    19,    20,    39,   119,    19,    20,
      49,     5,     3,   125,   126,   127,   128,   129,   130,   131,
     132,     3,   134,     3,     3,   169,   137,     3,     3,   173,
       3,    46,    47,     3,     5,    46,    47,     1,     6,     3,
       3,     9,    10,    11,    12,    13,    38,   159,   160,    45,
      14,    15,    16,    17,    18,     4,   168,    38,   169,     3,
       6,    38,   173,    27,    28,    29,    30,     4,    32,    33,
      34,    35,    36,    37,     3,     6,     4,     3,    38,     4,
      39,    45,    46,    47,    48,    14,    15,    16,    17,    18,
       8,    45,    70,    -1,    -1,     3,    -1,    -1,    27,    28,
      29,    30,    -1,    32,    33,    34,    35,    36,    37,    -1,
      18,    -1,    -1,    -1,    -1,    -1,    45,    46,    47,    48,
      28,    29,    30,    -1,    32,    33,    34,    35,    36,    37,
       4,    -1,     9,    10,    11,    12,    13,    45,    46,    47,
      48,     5,    -1,     4,    -1,    19,    20,    21,    22,    23,
      24,    25,    26,     4,    18,    -1,    -1,    -1,    19,    20,
       4,    38,     4,    -1,     4,    -1,    -1,    -1,    19,    20,
      34,    -1,    46,    47,     4,    19,    20,    19,    20,    19,
      20,    45,    46,    47,    48,    46,    47,    -1,    -1,    19,
      20,    -1,     4,     4,    18,    46,    47,     9,    10,    11,
      12,    13,    46,    47,    46,    47,    46,    47,    19,    20,
      34,    -1,    -1,    -1,    -1,    -1,    46,    47,    19,    20,
      -1,    45,    46,    47,    48,    49,    19,    20,    21,    22,
      23,    24,    25,    26,    -1,    46,    47,    38,    19,    20,
      19,    20,    19,    20,    -1,    46,    47,    -1,    -1,    -1,
      -1,    -1,    -1,    46,    47,    -1,    -1,    38,    -1,    38,
      -1,    38,    -1,    -1,    -1,    46,    47,    46,    47,    46,
      47
  };

  /* STOS_[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
  const unsigned char
  Parser::yystos_[] =
  {
         0,     7,    51,    52,    42,     0,     7,    53,    54,    55,
       8,    49,    53,     1,    40,    44,    49,    56,    57,    58,
      59,    60,    49,    56,     8,    49,    58,    41,    41,    41,
      56,    58,     5,    18,    34,    45,    46,    47,    48,    61,
      66,    67,    68,    69,    49,    49,    66,     3,    28,    29,
      30,    32,    33,    35,    36,    37,    64,    65,    66,    70,
      71,    61,    45,    48,     5,     3,    71,    64,    67,     3,
       3,     3,     3,     3,     3,     3,     6,    19,    20,    46,
      47,     5,     3,    67,    69,     4,    38,    31,    49,    73,
      73,    64,     3,    14,    15,    16,    17,    27,    62,    63,
      64,    72,    62,    64,    64,    64,    64,    64,    64,     1,
      62,    67,    67,     4,    38,     4,    62,    64,    62,     3,
       9,    10,    11,    12,    13,    38,    21,    22,    23,    24,
      25,    26,    38,     4,    38,     6,     6,    38,     4,    64,
       4,    64,    62,    62,    62,    62,    62,    64,    64,    64,
      64,    64,    64,    64,    64,    64,    67,     4,     4,    38,
      38,     4,     4,    64,    64,     6,    39,     4,    38,     3,
      64,    67,     4,    38,    67,     4,     6
  };

#if YYDEBUG
  /* TOKEN_NUMBER_[YYLEX-NUM] -- Internal symbol number corresponding
     to YYLEX-NUM.  */
  const unsigned short int
  Parser::yytoken_number_[] =
  {
         0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304
  };
#endif

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
  const unsigned char
  Parser::yyr1_[] =
  {
         0,    50,    51,    52,    53,    53,    54,    54,    55,    56,
      56,    57,    57,    57,    57,    57,    58,    58,    58,    58,
      59,    59,    60,    61,    61,    62,    62,    62,    62,    62,
      62,    62,    62,    62,    63,    63,    63,    63,    63,    63,
      63,    64,    64,    64,    64,    64,    64,    65,    65,    65,
      65,    65,    65,    66,    66,    66,    66,    67,    67,    68,
      68,    69,    69,    70,    70,    70,    70,    70,    71,    72,
      72,    72,    73,    73
  };

  /* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
  const unsigned char
  Parser::yyr2_[] =
  {
         0,     2,     2,     4,     0,     2,     2,     2,     3,     0,
       2,    10,    16,     3,     3,     4,     1,     2,     1,     2,
       7,     7,     1,     1,     3,     1,     3,     1,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       4,     1,     3,     3,     3,     3,     3,     1,     1,     1,
       4,     6,     4,     1,     1,     1,     1,     1,     2,     1,
       2,     1,     1,     4,     1,     6,     8,    10,     5,     1,
       1,     1,     1,     1
  };

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
  /* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
     First, the terminals, then, starting at \a yyntokens_, nonterminals.  */
  const char*
  const Parser::yytname_[] =
  {
    "\"end of file\"", "error", "$undefined", "\"(\"", "\")\"", "\"{\"",
  "\"}\"", "\"[\"", "\"]\"", "\"and\"", "\"or\"", "\"xor\"", "\"imp\"",
  "\"eqv\"", "\"not\"", "\"t\"", "\"f\"", "\"?b\"", "\"?c\"", "\"*\"",
  "\"/\"", "\"!=\"", "\"=\"", "\">\"", "\"<\"", "\">=\"", "\"<=\"",
  "COND_REAL_FUNC", "\"portValue\"", "\"send\"", "\"cellPos\"",
  "\"thisPort\"", "\"if\"", "\"ifu\"", "\"const function\"",
  "\"without parameter function\"", "\"unary function\"",
  "\"binary function\"", "\",\"", "\"..\"", "\"rule\"", "\":\"", "\"top\"",
  "\"else\"", "\"zone\"", "UINT", "\"+\"", "\"-\"", "UREAL", "STRING",
  "$accept", "START", "TOPSECTION", "SECTIONTUPLA", "SECTION", "SECNAME",
  "PARAMTUPLA", "PARAM", "RULELIST", "RULE", "ELSERULE", "RESULT",
  "BOOLEXP", "REALRELEXP", "REALEXP", "IDREF", "CONSTANT", "INT", "REAL",
  "SIGN", "FUNCTION", "CELLREF", "BOOL", "PORTNAME", 0
  };
#endif

#if YYDEBUG
  /* YYRHS -- A `-1'-separated list of the rules' RHS.  */
  const Parser::rhs_number_type
  Parser::yyrhs_[] =
  {
        51,     0,    -1,    52,    53,    -1,     7,    42,     8,    56,
      -1,    -1,    54,    53,    -1,    55,    56,    -1,    55,    58,
      -1,     7,    49,     8,    -1,    -1,    57,    56,    -1,    44,
      41,    49,     5,     3,    67,    38,    67,     4,     6,    -1,
      44,    41,    49,     5,     3,    67,    38,    67,     4,    39,
       3,    67,    38,    67,     4,     6,    -1,    49,    41,    49,
      -1,    49,    41,    66,    -1,    49,    41,    49,    71,    -1,
      59,    -1,    59,    58,    -1,    60,    -1,     1,    58,    -1,
      40,    41,    61,    61,     5,    62,     6,    -1,    40,    41,
      61,    61,     5,     1,     6,    -1,    49,    -1,    66,    -1,
       5,    64,     6,    -1,    72,    -1,     3,    62,     4,    -1,
      63,    -1,    14,    62,    -1,    62,     9,    62,    -1,    62,
      10,    62,    -1,    62,    11,    62,    -1,    62,    12,    62,
      -1,    62,    13,    62,    -1,    64,    21,    64,    -1,    64,
      22,    64,    -1,    64,    23,    64,    -1,    64,    24,    64,
      -1,    64,    25,    64,    -1,    64,    26,    64,    -1,    27,
       3,    64,     4,    -1,    65,    -1,     3,    64,     4,    -1,
      64,    46,    64,    -1,    64,    47,    64,    -1,    64,    19,
      64,    -1,    64,    20,    64,    -1,    71,    -1,    66,    -1,
      70,    -1,    28,     3,    73,     4,    -1,    29,     3,    73,
      38,    64,     4,    -1,    30,     3,    64,     4,    -1,    67,
      -1,    68,    -1,    34,    -1,    18,    -1,    45,    -1,    69,
      45,    -1,    48,    -1,    69,    48,    -1,    46,    -1,    47,
      -1,    36,     3,    64,     4,    -1,    35,    -1,    37,     3,
      64,    38,    64,     4,    -1,    32,     3,    62,    38,    64,
      38,    64,     4,    -1,    33,     3,    62,    38,    64,    38,
      64,    38,    64,     4,    -1,     3,    67,    38,    67,     4,
      -1,    15,    -1,    16,    -1,    17,    -1,    31,    -1,    49,
      -1
  };

  /* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
     YYRHS.  */
  const unsigned short int
  Parser::yyprhs_[] =
  {
         0,     0,     3,     6,    11,    12,    15,    18,    21,    25,
      26,    29,    40,    57,    61,    65,    70,    72,    75,    77,
      80,    88,    96,    98,   100,   104,   106,   110,   112,   115,
     119,   123,   127,   131,   135,   139,   143,   147,   151,   155,
     159,   164,   166,   170,   174,   178,   182,   186,   188,   190,
     192,   197,   204,   209,   211,   213,   215,   217,   219,   222,
     224,   227,   229,   231,   236,   238,   245,   254,   265,   271,
     273,   275,   277,   279
  };

  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
  const unsigned char
  Parser::yyrline_[] =
  {
         0,    74,    74,    76,    78,    79,    81,    82,    84,    86,
      87,    89,    90,    91,    92,    93,    95,    96,    97,    98,
     100,   101,   103,   105,   106,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   118,   119,   120,   121,   122,   123,
     124,   126,   127,   128,   129,   130,   131,   133,   134,   135,
     136,   137,   138,   140,   141,   142,   143,   145,   146,   148,
     149,   151,   152,   154,   155,   156,   157,   158,   160,   165,
     166,   167,   169,   170
  };

  // Print the state stack on the debug stream.
  void
  Parser::yystack_print_ ()
  {
    *yycdebug_ << "Stack now";
    for (state_stack_type::const_iterator i = yystate_stack_.begin ();
	 i != yystate_stack_.end (); ++i)
      *yycdebug_ << ' ' << *i;
    *yycdebug_ << std::endl;
  }

  // Report on the debug stream that the rule \a yyrule is going to be reduced.
  void
  Parser::yy_reduce_print_ (int yyrule)
  {
    unsigned int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    /* Print the symbols being reduced, and their result.  */
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
	       << " (line " << yylno << "):" << std::endl;
    /* The symbols being reduced.  */
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
		       yyrhs_[yyprhs_[yyrule] + yyi],
		       &(yysemantic_stack_[(yynrhs) - (yyi + 1)]),
		       &(yylocation_stack_[(yynrhs) - (yyi + 1)]));
  }
#endif // YYDEBUG

  /* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
  Parser::token_number_type
  Parser::yytranslate_ (int t)
  {
    static
    const token_number_type
    translate_table[] =
    {
           0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49
    };
    if ((unsigned int) t <= yyuser_token_number_max_)
      return translate_table[t];
    else
      return yyundef_token_;
  }

  const int Parser::yyeof_ = 0;
  const int Parser::yylast_ = 350;
  const int Parser::yynnts_ = 24;
  const int Parser::yyempty_ = -2;
  const int Parser::yyfinal_ = 5;
  const int Parser::yyterror_ = 1;
  const int Parser::yyerrcode_ = 256;
  const int Parser::yyntokens_ = 50;

  const unsigned int Parser::yyuser_token_number_max_ = 304;
  const Parser::token_number_type Parser::yyundef_token_ = 2;


/* Line 1054 of lalr1.cc  */
#line 1 "[Bison:b4_percent_define_default]"

} // DEVS

/* Line 1054 of lalr1.cc  */
#line 1660 "parser.tab.cc"


/* Line 1056 of lalr1.cc  */
#line 172 "parser.yy"
 // dodatocny kod

void DEVS::Parser::error(const Parser::location_type& l, const std::string& m)
{
    driver->error << "Error " << l.begin.line << ":" << l.begin.column << "-" << l.end.column << " " << m << std::endl;
}

