#include <iostream>
#include <QApplication>
#include <QTranslator>
#include "cellulamainwindow.h"

int main(int argc, char* argv[])
{
    QApplication app(argc, argv);
    Q_INIT_RESOURCE(res);
    app.setApplicationName(QString("Cellula"));
    app.setOrganizationName(QString("nou"));

    QString locale = QLocale::system().name();
    QTranslator tr;
    tr.load(":/cellula_"+locale);
    app.installTranslator(&tr);

    CellulaMainWindow window;
    window.show();
    return app.exec();
}
