#ifndef _SCANNER_HH_NOU_
#define _SCANNER_HH_NOU_

#ifndef YY_DECL

#define	YY_DECL			\
    TreeScanner::TreeToken           \
    TreeScanner::lex(	\
	int *yylval)
#endif

#ifndef __FLEX_LEXER_H
#define yyFlexLexer TreeScannerFlexLexer
#include <FlexLexer.h>
#undef yyFlexLexer
#endif

class TreeScanner : TreeScannerFlexLexer
{
    public:
    typedef enum
    {
        END,
        STATES,
        NEIGHBORS,
        NODES,
        //EQV,
        NUMBER
    }TreeToken;
    TreeScanner(std::istream *in = 0, std::ostream *out = 0) : TreeScannerFlexLexer(in, out)
    {
    }
    virtual TreeToken lex(int *yylval);
};

#endif // _SCANNER_HH_NOU_

